## baresip 0.5.10

=== Makefile ===
#
# Makefile
#
# Copyright (C) 2010 Creytiv.com
#
#
# Internal features:
#
#   USE_TLS           Enable SIP over TLS transport
#   USE_VIDEO         Enable Video-support
#

USE_VIDEO := 1

PROJECT	  := baresip
VERSION   := 0.5.10
DESCR     := "Baresip is a modular SIP User-Agent with audio and video support"

# Verbose and silent build modes
ifeq ($(V),)
HIDE=@
endif

ifndef LIBRE_MK
LIBRE_MK  := $(shell [ -f ../re/mk/re.mk ] && \
	echo "../re/mk/re.mk")
ifeq ($(LIBRE_MK),)
LIBRE_MK  := $(shell [ -f ../re-$(VERSION)/mk/re.mk ] && \
	echo "../re-$(VERSION)/mk/re.mk")
endif
ifeq ($(LIBRE_MK),)
LIBRE_MK  := $(shell [ -f /usr/share/re/re.mk ] && \
	echo "/usr/share/re/re.mk")
endif
ifeq ($(LIBRE_MK),)
LIBRE_MK  := $(shell [ -f /usr/local/share/re/re.mk ] && \
	echo "/usr/local/share/re/re.mk")
endif
endif

include $(LIBRE_MK)
include mk/modules.mk

ifndef LIBREM_PATH
LIBREM_PATH	:= $(shell [ -d ../rem ] && echo "../rem")
endif


CFLAGS    += -I. -Iinclude -I$(LIBRE_INC) -I$(SYSROOT)/include
CFLAGS    += -I$(LIBREM_PATH)/include
CFLAGS    += -I$(SYSROOT)/local/include/rem -I$(SYSROOT)/include/rem

CXXFLAGS  += -I. -Iinclude -I$(LIBRE_INC)
CXXFLAGS  += -I$(LIBREM_PATH)/include
CXXFLAGS  += -I$(SYSROOT)/local/include/rem -I$(SYSROOT)/include/rem
CXXFLAGS  += $(EXTRA_CXXFLAGS)

# XXX: common for C/C++
CPPFLAGS += -DHAVE_INTTYPES_H

ifneq ($(LIBREM_PATH),)
CLANG_OPTIONS  += -I$(LIBREM_PATH)/include
endif

ifeq ($(OS),win32)
STATIC    := yes
endif

ifneq ($(SYSROOT),)
ifeq ($(OS),freebsd)
CFLAGS += -I$(SYSROOT)/local/include
endif
ifeq ($(OS),openbsd)
CFLAGS += -isystem $(SYSROOT)/local/include
endif
endif


# Optional dependencies
ifneq ($(USE_VIDEO),)
CFLAGS    += -DUSE_VIDEO=1
endif
ifneq ($(STATIC),)
CFLAGS    += -DSTATIC=1
CXXFLAGS  += -DSTATIC=1
endif
CFLAGS    += -DMODULE_CONF

INSTALL := install
ifeq ($(DESTDIR),)
PREFIX  := /usr/local
else
PREFIX  := /usr
endif
BINDIR	:= $(PREFIX)/bin
INCDIR  := $(PREFIX)/include
BIN	:= $(PROJECT)$(BIN_SUFFIX)
TEST_BIN	:= selftest$(BIN_SUFFIX)
SHARED  := lib$(PROJECT)$(LIB_SUFFIX)
STATICLIB  := libbaresip.a
ifeq ($(STATIC),)
MOD_BINS:= $(patsubst %,%$(MOD_SUFFIX),$(MODULES))
endif
APP_MK	:= src/srcs.mk
TEST_MK	:= test/srcs.mk
MOD_MK	:= $(patsubst %,modules/%/module.mk,$(MODULES))
MOD_BLD	:= $(patsubst %,$(BUILD)/modules/%,$(MODULES))
LIBDIR     := $(PREFIX)/lib
MOD_PATH   := $(LIBDIR)/$(PROJECT)/modules
SHARE_PATH := $(PREFIX)/share/$(PROJECT)
CFLAGS     += -DPREFIX=\"$(PREFIX)\"
CFLAGS    += -DMOD_PATH=\"$(MOD_PATH)\"
CFLAGS    += -DSHARE_PATH=\"$(SHARE_PATH)\"


all: sanity $(MOD_BINS) $(BIN)

.PHONY: modules
modules:	$(MOD_BINS)

include $(APP_MK)
include $(TEST_MK)
include $(MOD_MK)

OBJS      := $(patsubst %.c,$(BUILD)/src/%.o,$(filter %.c,$(SRCS)))
OBJS      += $(patsubst %.m,$(BUILD)/src/%.o,$(filter %.m,$(SRCS)))
OBJS      += $(patsubst %.S,$(BUILD)/src/%.o,$(filter %.S,$(SRCS)))

APP_OBJS  := $(OBJS) $(patsubst %.c,$(BUILD)/src/%.o,$(APP_SRCS)) $(MOD_OBJS)

LIB_OBJS  := $(OBJS) $(MOD_OBJS)

TEST_OBJS := $(patsubst %.c,$(BUILD)/test/%.o,$(filter %.c,$(TEST_SRCS)))
TEST_OBJS += $(patsubst %.cpp,$(BUILD)/test/%.o,$(filter %.cpp,$(TEST_SRCS)))

ifneq ($(LIBREM_PATH),)
LIBS	+= -L$(LIBREM_PATH)
endif

# Static build: include module linker-flags in binary
ifneq ($(STATIC),)
LIBS      += $(MOD_LFLAGS)
else
LIBS      += -L$(SYSROOT)/local/lib
MOD_LFLAGS += -L$(SYSROOT)/local/lib
endif

LIBS      += -lrem -lm
LIBS      += -L$(SYSROOT)/lib

ifeq ($(OS),win32)
TEST_LIBS += -static-libgcc
endif


-include $(APP_OBJS:.o=.d)

-include $(TEST_OBJS:.o=.d)


sanity:
ifeq ($(LIBRE_MK),)
	@echo "ERROR: Missing common makefile for libre. Check LIBRE_MK"
	@exit 2
endif
ifeq ($(LIBRE_INC),)
	@echo "ERROR: Missing header files for libre. Check LIBRE_INC"
	@exit 2
endif
ifeq ($(LIBRE_SO),)
	@echo "ERROR: Missing library files for libre. Check LIBRE_SO"
	@exit 2
endif

Makefile:	mk/*.mk $(MOD_MK) $(LIBRE_MK)


$(SHARED): $(LIB_OBJS)
	@echo "  LD      $@"
	$(HIDE)$(LD) $(LFLAGS) $(SH_LFLAGS) $^ -L$(LIBRE_SO) -lre $(LIBS) -o $@

$(STATICLIB): $(LIB_OBJS)
	@echo "  AR      $@"
	@rm -f $@; $(AR) $(AFLAGS) $@ $^
ifneq ($(RANLIB),)
	@echo "  RANLIB  $@"
	$(HIDE)$(RANLIB) $@
endif

libbaresip.pc:
	@echo 'prefix='$(PREFIX) > libbaresip.pc
	@echo 'exec_prefix=$${prefix}' >> libbaresip.pc
	@echo 'libdir=$${prefix}/lib' >> libbaresip.pc
	@echo 'includedir=$${prefix}/include' >> libbaresip.pc
	@echo '' >> libbaresip.pc
	@echo 'Name: libbaresip' >> libbaresip.pc
	@echo 'Description: $(DESCR)' >> libbaresip.pc
	@echo 'Version: '$(VERSION) >> libbaresip.pc
	@echo 'URL: http://www.creytiv.com/baresip.html' >> libbaresip.pc
	@echo 'Libs: -L$${libdir} -lbaresip' >> libbaresip.pc
	@echo 'Cflags: -I$${includedir}' >> libbaresip.pc

# GPROF requires static linking
$(BIN):	$(APP_OBJS)
	@echo "  LD      $@"
ifneq ($(GPROF),)
	$(HIDE)$(LD) $(LFLAGS) $(APP_LFLAGS) $^ ../re/libre.a $(LIBS) -o $@
else
	$(HIDE)$(LD) $(LFLAGS) $(APP_LFLAGS) $^ \
		-L$(LIBRE_SO) -lre $(LIBS) -o $@
endif


.PHONY: test
test:	$(TEST_BIN)
	./$(TEST_BIN)

$(TEST_BIN):	$(STATICLIB) $(TEST_OBJS)
	@echo "  LD      $@"
	$(HIDE)$(CXX) $(LFLAGS) $(TEST_OBJS) \
		-L$(LIBRE_SO) -L. \
		-l$(PROJECT) -lre $(LIBS) $(TEST_LIBS) -o $@

$(BUILD)/%.o: %.c $(BUILD) Makefile $(APP_MK)
	@echo "  CC      $@"
	$(HIDE)$(CC) $(CFLAGS) -c $< -o $@ $(DFLAGS)

$(BUILD)/%.o: %.cpp $(BUILD) Makefile $(APP_MK)
	@echo "  CXX     $@"
	$(HIDE)$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c $< -o $@ $(DFLAGS)

$(BUILD)/%.o: %.m $(BUILD) Makefile $(APP_MK)
	@echo "  OC      $@"
	$(HIDE)$(CC) $(CFLAGS) $(OBJCFLAGS) -c $< -o $@ $(DFLAGS)

$(BUILD)/%.o: %.S $(BUILD) Makefile $(APP_MK)
	@echo "  AS      $@"
	$(HIDE)$(CC) $(CFLAGS) -c $< -o $@ $(DFLAGS)

$(BUILD): Makefile
	@mkdir -p $(BUILD)/src $(MOD_BLD) $(BUILD)/test/mock $(BUILD)/test/sip
	@touch $@

install: $(BIN) $(MOD_BINS)
	@mkdir -p $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 0755 $(BIN) $(DESTDIR)$(BINDIR)
	@mkdir -p $(DESTDIR)$(MOD_PATH)
	$(INSTALL) -m 0644 $(MOD_BINS) $(DESTDIR)$(MOD_PATH)
	@mkdir -p $(DESTDIR)$(SHARE_PATH)
	$(INSTALL) -m 0644 share/* $(DESTDIR)$(SHARE_PATH)

install-dev: install-shared install-static

install-shared: $(SHARED) libbaresip.pc
	@mkdir -p $(DESTDIR)$(INCDIR)
	$(INSTALL) -Cm 0644 include/baresip.h $(DESTDIR)$(INCDIR)
	@mkdir -p $(DESTDIR)$(LIBDIR) $(DESTDIR)$(LIBDIR)/pkgconfig
	$(INSTALL) -m 0644 $(SHARED) $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m 0644 libbaresip.pc $(DESTDIR)$(LIBDIR)/pkgconfig

install-static: $(STATICLIB)
	@mkdir -p $(DESTDIR)$(INCDIR)
	$(INSTALL) -Cm 0644 include/baresip.h $(DESTDIR)$(INCDIR)
	@mkdir -p $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m 0644 $(STATICLIB) $(DESTDIR)$(LIBDIR)

uninstall:
	@rm -f $(DESTDIR)$(PREFIX)/bin/$(BIN)
	@rm -rf $(DESTDIR)$(MOD_PATH)
	@rm -f $(DESTDIR)$(PREFIX)/lib/$(SHARED)
	@rm -f $(DESTDIR)$(PREFIX)/lib/$(STATICLIB)
	@rm -f $(DESTDIR)$(PREFIX)/lib/pkgconfig/libbaresip.pc

.PHONY: clean
clean:
	@rm -rf $(BIN) $(MOD_BINS) $(SHARED) $(BUILD) $(TEST_BIN) \
		$(STATICLIB) libbaresip.pc
	@rm -f *stamp \
	`find . -name "*.[od]"` \
	`find . -name "*~"` \
	`find . -name "\.\#*"`

.PHONY: ccheck
ccheck:
	@ccheck.pl > /dev/null

version:
	@perl -pi -e 's/BARESIP_VERSION.*/BARESIP_VERSION \"$(VERSION)"/' \
		include/baresip.h
	@perl -pi -e "s/PROJECT_NUMBER         = .*/\
PROJECT_NUMBER         = $(VERSION)/" \
		mk/Doxyfile
	@echo "updating version number to $(VERSION)"

src/static.c: $(BUILD) Makefile $(APP_MK) $(MOD_MK)
	@echo "  SH      $@"
	@echo "/* static.c - autogenerated by makefile */"  > $@
	@echo "#include <re_types.h>"  >> $@
	@echo "#include <re_mod.h>"  >> $@
	@echo ""  >> $@
	@for n in $(MODULES); do \
		echo "extern const struct mod_export exports_$${n};" >> $@ ; \
	done
	@echo ""  >> $@
	@echo "const struct mod_export *mod_table[] = {"  >> $@
	@for n in $(MODULES); do \
		echo "  &exports_$${n},"  >> $@  ; \
	done
	@echo "  NULL"  >> $@
	@echo "};"  >> $@

=== debian/changelog ===
baresip (0.5.10-1build1) cosmic; urgency=medium

  * Rebuild against new libsndio7.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Aug 2018 08:06:07 +0200

baresip (0.5.10-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Stop explicitly enable b2bua module: Auto-detected now.
  * Update package relations:
    + Stop build-depend on libspeex-dev: speex module dropped upstream.
  * Update long descriptions:
    + Stop advertise support for Speex codec.
    + Fix advertise support for JSON-over-TCP control interface
      (included since 0.5.9-1).

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 10 Aug 2018 13:40:40 +0200

baresip (0.5.9-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).
    Closes: bug#889522, Thanks to Adrian Bunk.
    Closes: bug#888344, Thanks to James Cowgill.

  [ Jonas Smedegaard ]
  * Declare compliance with Debian Policy 4.1.4.
  * Update copyright info:
    + Extend coverage for main upstream authors.
    + Add Files section lacking licensing.
  * Update package relations: Tighten build-dependency on libre-dev.
  * Update Vcs-* fields: Source hosted at Salsa.debian.org now.
  * Remove Ramakrishnan Muthhukrishnan as uploader: Thanks for your
    interest in the past, Ram.
    Closes: Bug#859278. Thanks to Mattia Rizzolo and the MIA team.

  [ Vasudev Kamath ]
  * Bump compat level to 10.
  * debhelper now uses versioned depend on >= 10~.
  * Add README.source indicating how to handle and upload package to
    archive.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sun, 03 Jun 2018 20:28:56 +0530

=== debian/control ===
Source: baresip
Section: comm
Priority: optional
Build-Depends: cdbs,
 debhelper (>= 10~),
 dh-buildinfo,
 libasound2-dev,
 libavahi-client-dev,
 libcodec2-dev,
 libdirectfb-dev [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x],
 libjack-dev,
 libgsm1-dev,
 libopus-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libpng-dev,
 libsdl2-dev,
 libsndfile1-dev,
 libsndio-dev,
 libspandsp-dev,
 libspeexdsp-dev,
 libtwolame-dev,
 libvpx-dev,
 libssl-dev,
 libmosquitto-dev,
 libevdev-dev [linux-any],
 portaudio19-dev,
 pkg-config,
 libre-dev (>= 0.5.7),
 librem-dev (>= 0.5.2),
 libavcodec-dev,
 libavformat-dev,
 libavdevice-dev,
 libswscale-dev,
 libx265-dev,
 libgstreamer1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libgtk2.0-dev,
 libcairo2-dev,
 libomxil-bellagio-dev,
 libmpg123-dev,
 libpulse-dev,
 libxext-dev,
 libx11-dev
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Vasudev Kamath <vasudev@copyninja.info>
Standards-Version: 4.1.4
Vcs-Git: https://salsa.debian.org/pkg-voip-team/baresip.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/baresip
Homepage: http://www.creytiv.com/baresip.html

Package: baresip
Architecture: all
Depends: ${cdbs:Depends},
 ${misc:Depends}
Recommends: ${cdbs:Recommends}
Description: portable and modular SIP user-agent - metapackage
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This metapackage will install baresip and all its optional features.

Package: baresip-core
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Description: portable and modular SIP user-agent - core parts
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 Some of above features are provided in separate packages baresip-gtk,
 baresip-ffmpeg, baresip-gstreamer and baresip-x11.

Package: baresip-gtk
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 baresip-core (= ${binary:Version})
Enhances: ${cdbs:Enhances}
Description: portable and modular SIP user-agent - GTK+ front-end
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video output: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package provides a GTK+ front-end for baresip.

Package: baresip-ffmpeg
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 baresip-core (= ${binary:Version})
Enhances: ${cdbs:Enhances}
Description: portable and modular SIP user-agent - FFmpeg codecs and formats
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package integrates FFmpeg codecs and formats with baresip.

Package: baresip-gstreamer
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 baresip-core (= ${binary:Version})
Enhances: ${cdbs:Enhances}
Description: portable and modular SIP user-agent - GStreamer pipelines
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package integrates GStreamer pipelines with baresip.

Package: baresip-x11
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 baresip-core (= ${binary:Version})
Enhances: ${cdbs:Enhances}
Description: portable and modular SIP user-agent - X11 features
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package provides various X11-related features for baresip.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright 2016-2018 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for baresip
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk

# Run this to update arch list: debian/rules clean DEB_MAINTAINER_MODE=1
# (in maintainer mode only, uses network and messes with control file)
ifneq (,$(DEB_MAINTAINER_MODE))
debian/control::
	debian/archs-update
endif
ARCHS_directfb := $(shell cat debian/ARCHS_directfb)

# Needs and module hints for core package
core-deps = asound2 avahi-client codec2 directfb jack gsm1 opus
core-deps += opencore-amrnb opencore-amrwb png sdl2 sndfile1 sndio
core-deps += spandsp speexdsp twolame vpx ssl mosquitto
core-deps-extra = libevdev-dev [linux-any]
core-deps-extra +=, portaudio19-dev
core-mods-extra = codec2 echo snapshot sndio
core-mods-extra += $(if $(filter $(ARCHS_directfb),$(DEB_HOST_ARCH)),directfb)

CDBS_BUILD_DEPENDS +=, $(patsubst %,$(comma) lib%-dev,$(core-deps))
CDBS_BUILD_DEPENDS +=, $(core-deps-extra), pkg-config
CDBS_BUILD_DEPENDS +=, libre-dev (>= 0.5.7)
CDBS_BUILD_DEPENDS +=, librem-dev (>= 0.5.2)
EXTRA_MODULES += $(core-mods-extra)

CDBS_DEPENDS_baresip +=, baresip-core

# Needs and module hints for module packages
ffmpeg-deps = avcodec avformat avdevice swscale x265
ffmpeg-mods = avformat avcodec h265
ffmpeg-mods-extra = swscale
gstreamer-deps = gstreamer1.0 gstreamer-plugins-base1.0
gstreamer-mods = gst1 gst_video1
gtk-deps = gtk2.0
gtk-mods = gtk
x11-deps = cairo2 omxil-bellagio mpg123 pulse xext x11
x11-mods = cairo omx pulse rst sdl2 vidinfo x11 x11grab

define MODULE_template =
CDBS_BUILD_DEPENDS +=, $$(patsubst %,$$(comma) lib%-dev,$$($1-deps))
EXTRA_MODULES += $$($1-mods-extra)
DEB_DH_INSTALL_ARGS_baresip-$1 = \
 $$(patsubst %,usr/lib/baresip/modules/%.so,$$($1-mods) $$($1-mods-extra)) \
 usr/lib/baresip/modules
# Do not install these modules as part of baresip
DEB_DH_INSTALL_ARGS_baresip-core += \
 $$(patsubst %,-X%.so,$$($1-mods) $$($1-mods-extra))
CDBS_RECOMMENDS_baresip +=, baresip-$1
CDBS_RECOMMENDS_baresip-core +=, avahi-daemon
CDBS_SUGGESTS_baresip-core +=, baresip-$1
CDBS_ENHANCES_baresip-$1 = baresip-core
endef
$(foreach module,ffmpeg gstreamer gtk x11,\
 $(eval $(call MODULE_template,$(module))))

DEB_MAKE_EXTRA_ARGS = V=1 PREFIX=/usr RELEASE=1 \
	EXTRA_MODULES="$(EXTRA_MODULES)" \
	EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" \
	EXTRA_LFLAGS="$(LDFLAGS)" \
	$(DEB_MAKE_PARALLEL)

DEB_MAKE_BUILD_TARGET = info all
DEB_MAKE_CHECK_TARGET = test
DEB_MAKE_INSTALL_TARGET = install DESTDIR=$(cdbs_make_curdestdir)

DEB_INSTALL_CHANGELOGS_ALL = docs/ChangeLog
DEB_INSTALL_DOCS_ALL += README.md docs/TODO
DEB_INSTALL_EXAMPLES_baresip-core = docs/examples/*

# LIBDIR for installation
LIBDIR=/usr/lib

## baresip 0.6.1

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 USE_VIDEO := 1
 
 PROJECT	  := baresip
-VERSION   := 0.5.10
+VERSION   := 0.6.1
 DESCR     := "Baresip is a modular SIP User-Agent with audio and video support"
 
 # Verbose and silent build modes
@@ -84,7 +84,6 @@
 CFLAGS    += -DSTATIC=1
 CXXFLAGS  += -DSTATIC=1
 endif
-CFLAGS    += -DMODULE_CONF
 
 INSTALL := install
 ifeq ($(DESTDIR),)

=== debian/changelog ===
baresip (0.6.1-1) unstable; urgency=medium

  [ upstream ]
  * New release.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 18 Feb 2019 13:30:38 +0100

baresip (0.6.1~20190207-1) unstable; urgency=medium

  [ upstream ]
  * snapshot...

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Extend coverage for main upstream authors.
    + Extend coverage of packaging.
  * Simplify rules.
    Stop build-depend on cdbs dh-buildinfo.
  * Update and unfuzz patches.
  * Update watch file:
    + Rewrite usage comment.
    + Simplify regular expressions.
  * Declare compliance with Debian Policy 4.3.0.
  * Generate manpage.
    Build-depend on help2man.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 11 Feb 2019 21:12:28 +0100

baresip (0.6.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update package relations:
    + Tighten build-dependency on libre-dev librem-dev.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 05 Dec 2018 13:18:50 +0100

baresip (0.5.11-2) unstable; urgency=medium

  * Fix extend patch 1002 to cover librem libspeexdsp libopencore-amrnb.
    Closes: Bug#912107. Thanks to Adrian Bunk.
  * Unfuzz patch 2001.
  * Fix build-depend on libvo-amrwbenc-dev.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 29 Nov 2018 19:56:17 +0100

baresip (0.5.11-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Set Rules-Requires-Root: no.
  * Declare compliance with Debian Policy 4.2.1.
  * Add patch 1002 to avoid hardcoded locations of system headers.
    Closes: Bug#910127. Thanks to Helmut Grohne.
    Reorder and Unfuzz patches.
  * Update package relations: Tighten build-dependency on librem-dev.
  * Enable new RTCP stats module.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 03 Oct 2018 09:11:28 +0200

=== debian/control ===
Source: baresip
Section: comm
Priority: optional
Build-Depends:
 debhelper (>= 10~),
 help2man,
 libasound2-dev,
 libavahi-client-dev,
 libavcodec-dev,
 libavdevice-dev,
 libavformat-dev,
 libcairo2-dev,
 libcodec2-dev,
 libdirectfb-dev [!hurd-any !kfreebsd-any],
 libevdev-dev [linux-any],
 libgsm1-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libgtk2.0-dev,
 libjack-dev,
 libmosquitto-dev,
 libmpg123-dev,
 libomxil-bellagio-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libopus-dev,
 libpng-dev,
 libpulse-dev,
 libre-dev (>= 0.6.0),
 librem-dev (>= 0.6.0),
 libsdl2-dev,
 libsndfile1-dev,
 libsndio-dev,
 libspandsp-dev,
 libspeexdsp-dev,
 libssl-dev,
 libswscale-dev,
 libtwolame-dev,
 libvo-amrwbenc-dev,
 libvpx-dev,
 libx11-dev,
 libx265-dev,
 libxext-dev,
 pkg-config,
 portaudio19-dev,
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
 Vasudev Kamath <vasudev@copyninja.info>,
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/pkg-voip-team/baresip.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/baresip
Homepage: http://www.creytiv.com/baresip.html
Rules-Requires-Root: no

Package: baresip
Architecture: all
Depends:
 baresip-core,
 ${misc:Depends},
Recommends:
 baresip-ffmpeg,
 baresip-gstreamer,
 baresip-gtk,
 baresip-x11,
Description: portable and modular SIP user-agent - metapackage
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This metapackage will install baresip and all its optional features.

Package: baresip-core
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 avahi-daemon,
Suggests:
 baresip-ffmpeg,
 baresip-gstreamer,
 baresip-gtk,
 baresip-x11,
Description: portable and modular SIP user-agent - core parts
 A modular SIP user-agent
 with support for audio and video, and many IETF standards
 such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 Some of above features are provided in separate packages
 baresip-gtk, baresip-ffmpeg, baresip-gstreamer and baresip-x11.

Package: baresip-gtk
Architecture: any
Depends:
 baresip-core (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 baresip-core,
Description: portable and modular SIP user-agent - GTK+ front-end
 A modular SIP user-agent
 with support for audio and video, and many IETF standards
 such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video output: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package provides a GTK+ front-end for baresip.

Package: baresip-ffmpeg
Architecture: any
Depends:
 baresip-core (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 baresip-core,
Description: portable and modular SIP user-agent - FFmpeg codecs and formats
 A modular SIP user-agent with support for audio and video, and many
 IETF standards such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package integrates FFmpeg codecs and formats with baresip.

Package: baresip-gstreamer
Architecture: any
Depends:
 baresip-core (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 baresip-core,
Description: portable and modular SIP user-agent - GStreamer pipelines
 A modular SIP user-agent
 with support for audio and video, and many IETF standards
 such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package integrates GStreamer pipelines with baresip.

Package: baresip-x11
Architecture: any
Depends:
 baresip-core (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 baresip-core,
Description: portable and modular SIP user-agent - X11 features
 A modular SIP user-agent
 with support for audio and video, and many IETF standards
 such as SIP, SDP, RTP/RTCP, STUN, TURN, and ICE.
 .
 Supports both IPv4 and IPv6, and the following features.
  * Audio codecs: AMR, G.711, G.722, G.726, GSM, L16, MPA, OPUS.
  * Video codecs: H.263, H.264, H.265, MPEG4, VP8, VP9.
  * Audio drivers: Alsa, GStreamer, JACK, OSS, Portaudio, sndio.
  * Video sources: FFmpeg avformat, Video4Linux2, X11 Grabber.
  * Video outputs: SDL2, X11, DirectFB.
  * NAT Traversal: STUN, TURN, ICE, NATBD, NAT-PMP, PCP.
  * Media encryption: SRTP, DTLS-SRTP.
  * DNS Service Discovery: Avahi.
  * Telemetry messaging: MQTT.
  * Control interfaces: JSON-over-TCP.
 .
 This package provides various X11-related features for baresip.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

DOCS = README.md docs/TODO

# generate manpage with help2man from -h option
_mkman = \
 help2man $(if $3,--name "$(strip $3)") --no-info --help-option -h --no-discard-stderr --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
 || [ $? -eq 254 ] || { $1 -h; false; }

# install into package baresip-$1 modules $($1-mods)
_installmods = dh_install --package baresip-$1 \
		$(patsubst %, usr/lib/baresip/modules/%.so, $($1-mods)) \
		usr/lib/baresip/modules

# module hints for core package
core-mods-extra = codec2 echo rtcpsummary snapshot sndio
ifeq (, $(filter hurd-% kfreebsd-%, $(DEB_HOST_ARCH)))
core-mods-extra += directfb
endif

# module hints for module packages
ffmpeg-mods = avformat avcodec h265 swscale
gstreamer-mods = gst1 gst_video1
gtk-mods = gtk
x11-mods = cairo omx pulse rst sdl2 vidinfo x11 x11grab

DEB_MAKE_EXTRA_ARGS = V=1 PREFIX=/usr RELEASE=1 \
	EXTRA_MODULES="$(core-mods-extra) swscale" \
	EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" \
	EXTRA_LFLAGS="$(LDFLAGS)" \
	DESTDIR=debian/tmp

override_dh_auto_build:
	dh_auto_build -- $(DEB_MAKE_EXTRA_ARGS) info all
	$(call _mkman, ./baresip, debian/baresip.1, \
		portable and modular command-line SIP user-agent)

override_dh_auto_install:
	dh_auto_install -- $(DEB_MAKE_EXTRA_ARGS)

override_dh_install:
	$(call _installmods,ffmpeg)
	$(call _installmods,gstreamer)
	$(call _installmods,gtk)
	$(call _installmods,x11)
	dh_install \
		$(patsubst %, --no-package baresip-%,\
			ffmpeg gstreamer gtk x11) \
		$(patsubst %, -X%.so,\
			$(ffmpeg-mods) $(gstreamer-mods) \
			$(gtk-mods) $(x11-mods))

override_dh_installchangelogs:
	dh_installchangelogs -- docs/ChangeLog

override_dh_installdocs:
	dh_installdocs --all -- $(DOCS)

%:
	dh $@

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://github.com/alfredh/baresip/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## baresip 0.6.6

=== debian/changelog ===
baresip (0.6.6-1~ab10+1) buster-ab-unstable; urgency=medium

  [ itd ]
  * New upstream version 0.6.6
  * Update patches for new release
  * debian/rules: more modules are built by default
  * Switch to debhelper 12
  * Make pkg-config substitutable (Closes: #944338)
  * Update debian/copyright to reflect module rename
  * Bump standards version, no changes required

  [ Stephan Suerken ]
  * [3cf05da] debian/patches/3000_fix_checks_that_stall_make.patch: Fix
    building, at least under buster.
  * [2c454cd] * debian/rules: -rst module.

 -- Stephan Sürken <absurd@debian.org>  Sun, 07 Jun 2020 14:29:18 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: comm
 Priority: optional
 Build-Depends:
- debhelper (>= 10~),
+ debhelper (>= 12~),
+ debhelper-compat (= 12),
  help2man,
  libasound2-dev,
- libavahi-client-dev,
  libavcodec-dev,
  libavdevice-dev,
  libavformat-dev,
@@ -13,12 +13,14 @@
  libcodec2-dev,
  libdirectfb-dev [!hurd-any !kfreebsd-any],
  libevdev-dev [linux-any],
+ libfdk-aac-dev <pkg.baresip.nonfree>,
  libgsm1-dev,
  libgstreamer-plugins-base1.0-dev,
  libgstreamer1.0-dev,
  libgtk2.0-dev,
  libjack-dev,
  libmosquitto-dev,
+ libmp3lame-dev,
  libmpg123-dev,
  libomxil-bellagio-dev,
  libopencore-amrnb-dev,
@@ -47,7 +49,7 @@
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/baresip.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/baresip
 Homepage: http://www.creytiv.com/baresip.html
@@ -86,8 +88,6 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Recommends:
- avahi-daemon,
 Suggests:
  baresip-ffmpeg,
  baresip-gstreamer,

=== debian/rules ===
--- 
+++ 
@@ -15,16 +15,16 @@
 		usr/lib/baresip/modules
 
 # module hints for core package
-core-mods-extra = codec2 echo rtcpsummary snapshot sndio
+core-mods-extra = rtcpsummary snapshot stdio
 ifeq (, $(filter hurd-% kfreebsd-%, $(DEB_HOST_ARCH)))
 core-mods-extra += directfb
 endif
 
 # module hints for module packages
-ffmpeg-mods = avformat avcodec h265 swscale
-gstreamer-mods = gst1 gst_video1
+ffmpeg-mods = avformat avcodec swscale
+gstreamer-mods = gst gst_video
 gtk-mods = gtk
-x11-mods = cairo omx pulse rst sdl2 vidinfo x11 x11grab
+x11-mods = cairo omx pulse sdl vidinfo x11 x11grab
 
 DEB_MAKE_EXTRA_ARGS = V=1 PREFIX=/usr RELEASE=1 \
 	EXTRA_MODULES="$(core-mods-extra) swscale" \
